;;------------------------------------------------------------------------------
;; This file is part of Farming Spirits.
;;
;; Farming Spirits is free software: you can redistribute it and/or modify
;; it under the terms of the GNU General Public License as published 
;; by the Free Software Foundation, either version 3 of the License, 
;; or (at your option) any later version.
;;
;; Farming Spirits is distributed in the hope that it will be useful, but WITHOUT 
;; ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
;; FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
;; for more details.
;;
;; You should have received a copy of the GNU General Public License 
;; along with Farming Spirits. If not, see https://www.gnu.org/licenses/. 
;;------------------------------------------------------------------------------

SCREEN_WIDTH_IN_BYTES     = 64
SCREEN_HEIGHT_IN_BYTES    = 32
SCREEN_WIDTH_IN_PIXELS    = 128
SCREEN_HEIGHT_IN_PIXELS   = 128
SCREEN_HEIGHT_WITHOUT_HUD = SCREEN_HEIGHT_IN_PIXELS - HUD_HEIGHT
SCREEN_WIDTH_IN_CHARS     = 16
SCREEN_HEIGHT_IN_CHARS    = 16

STRING_CHAR_WIDTH        = 4
STRING_CHAR_HEIGHT       = 8

;; HUD GENERAL
    HUD_X                    = 0
    HUD_Y                    = (SCREEN_HEIGHT_IN_PIXELS/8)*7    ;; filas de 16 pixeles
    HUD_WIDTH                = SCREEN_WIDTH_IN_BYTES
    HUD_HEIGHT               = 16
;;

;; HUD COLOURS AND SPRITES
    HUD_BACKGROUND_COLOR = 0x00
    HUD_Y_ICONS = HUD_Y + (HUD_HEIGHT / 4)*(2-1)    ;; Y + (HEIGHT/4)*(fila-1)- OFFSET
    HUD_OFFSET = HUD_HEARTS_SPRITE_WIDTH    ;; antes con separacion = 6
        HUD_NUM_DESPLAZAMIENTOS = 2 ;; 1->*2, 2->*4                                 ;OJO CAMBIAR A MANO SEGUN HUD_OFFSET
        HUD_NUM_SOBRANTE        = HUD_OFFSET - (2*(2)) ;; = HUD_OFFSET - (2^HUD_NUM_DESPLAZAMIENTOS)   ;OJO CAMBIAR A MANO SEGUN HUD_OFFSET
;;
;; HEARTS

    ;HUD_X_ICONS = HUD_X + (HUD_WIDTH/3)                ;;
    ;HUD_HEARTS_SPRITE_X = HUD_X + (HUD_WIDTH/4)*(3-1) + 8  ;; colocado a la derecha
    ;HUD_HEARTS_SPRITE_X = HUD_WIDTH-2 - (HUD_HEARTS_SPRITE_WIDTH*2) -2
    ;HUD_HEARTS_SPRITE_Y = HUD_Y_ICONS   ;; 4 filas, la 2a
    HUD_HEARTS_SPRITE_WIDTH = 4
    ;HUD_HEARTS_SPRITE_HEIGHT = 8
    ;                                    Dos casillas       Offset
    HUD_HEARTS_SPRITE_X = HUD_WIDTH - (LANE_SLOT_WIDTH*2) + 1
    HUD_HEARTS_SPRITE_Y = HUD_Y-1
    HUD_HEARTS_OFFSET_X = 3
    
;;

;; ATTACK
    HUD_ATTACK_SPRITE_WIDTH = 4
    HUD_ATTACK_SPRITE_HEIGHT = 16
    ;;--------------------------------
    HUD_ATTACK_SPRITE_X = (HUD_WIDTH/2) ;;HUD_X + (HUD_WIDTH/4)*(2 -1) + 8  ;; segunda columna
    ;HUD_ATTACK_SPRITE_X_0 = HUD_ATTACK_SPRITE_X + HUD_ATTACK_SPRITE_WIDTH + 1 ;; en medio
    HUD_ATTACK_SPRITE_X_0 = HUD_ATTACK_SPRITE_X - HUD_ATTACK_SPRITE_WIDTH/2
    HUD_ATTACK_SPRITE_X_1 = HUD_ATTACK_SPRITE_X_0 - HUD_ATTACK_SPRITE_WIDTH - 1           ;; izquierda
    HUD_ATTACK_SPRITE_X_2 = HUD_ATTACK_SPRITE_X_0 + HUD_ATTACK_SPRITE_WIDTH +1  ;; derecha
    HUD_ATTACK_SPRITE_Y = HUD_Y

;;

;;LANES
LANE_SLOT_HEIGHT                   = 16
LANE_SLOT_WIDTH                    = LANE_SLOT_HEIGHT / 4
LANE_SLOT_SEPARATION               = LANE_SLOT_HEIGHT / 4
LANE_SLOT_SEPARATION_Y             = (LANE_SLOT_HEIGHT*2+1) /3 +1
LANE_TIMER_INIT_VALUE              = 5
LANE_NUM_SLOTS                     = 5
LANE_MOVE_ENTITY_FRAME_COUNTER     = LANE_SLOT_WIDTH + LANE_SLOT_SEPARATION
LANE_MOVE_ENTITY_PER_FRAME_COUNTER = 3 ;; Move the lane one unit per X frames

LANE_SLOT_START_POS_X          = (16 / 4) * 2
LANE_PLAYER_SLOT_POS_X         = (16 / 4) * 13
LANE_TIMER_POS_X               = (16 / 4) * 1
LANE_1_LANES_START_POS_Y       = 48
LANE_2_LANES_START_POS_Y_1     = 32
LANE_2_LANES_START_POS_Y_2     = 64
LANE_3_LANES_START_POS_Y_1     = 16
LANE_3_LANES_START_POS_Y_2     = 48
LANE_3_LANES_START_POS_Y_3     = 80

LANE_STATE_UPDATING_COUNTER    = 0x00
LANE_STATE_UPDATING_TIMER      = 0x01
LANE_STATE_MOVING              = 0x02
LANE_STATE_LAST_MOVING_FRAME   = 0x04


PLAYER_START_POS_X             = (16 / 4) * 12
PLAYER_DAMAGE_FRAME_COUNT_INIT = 4

ENTITY_CONST_WIDTH             = LANE_SLOT_WIDTH
ENTITY_CONST_HEIGHT            = LANE_SLOT_HEIGHT-4

PLAYER_MAX_HEALTH              = 3

;; BUFFER POINTERS
BUFFER_PTR_1  = 0xC000
BUFFER_PTR_2  = 0xC400

;; LEVEL CREATION CONSTANTS

LEVEL_DATA_MASK_1BITS          = 0b00000001
LEVEL_DATA_MASK_2BITS          = 0b00000011
LEVEL_DATA_MASK_3BITS          = 0b00000111
LEVEL_DATA_MASK_4BITS          = 0b00001111

LEVEL_NUM_LANES_1              = 0b00000001
LEVEL_NUM_LANES_2              = 0b00000010
LEVEL_NUM_LANES_3              = 0b00000011
        
LEVEL_NUM_ATTACKS_1            = 0b00000100
LEVEL_NUM_ATTACKS_2            = 0b00001000
LEVEL_NUM_ATTACKS_3            = 0b00001100
        
LEVEL_MIN_HP_1                 = 0b00000000
LEVEL_MIN_HP_2                 = 0b00010000
LEVEL_MIN_HP_3                 = 0b00100000
LEVEL_MIN_HP_4                 = 0b00110000
        
LEVEL_MAX_HP_1                 = 0b00000000
LEVEL_MAX_HP_2                 = 0b01000000
LEVEL_MAX_HP_3                 = 0b10000000
LEVEL_MAX_HP_4                 = 0b11000000
        
LEVEL_CMD_END                  = 0b00000000
LEVEL_CMD_SPAWN                = 0b00000001
LEVEL_CMD_WAIT                 = 0b00000010
        
LEVEL_SPAWN_1                  = 0b00000000
LEVEL_SPAWN_2                  = 0b00000100
LEVEL_SPAWN_3                  = 0b00001000
LEVEL_SPAWN_4                  = 0b00001100

LEVEL_SPAWN_FIRE_SPIRIT         = 0b00000000
LEVEL_SPAWN_WATER_SPIRIT        = 0b00010000
LEVEL_SPAWN_ELECTRIC_SPIRIT     = 0b00100000
LEVEL_SPAWN_MIXED_SPIRIT        = 0b00110000
LEVEL_SPAWN_LETTER_SPIRIT       = 0b01000000
LEVEL_SPAWN_HEART_SPIRIT        = 0b01010000
     
LEVEL_WAIT_1                   = 0b00000100
LEVEL_WAIT_2                   = 0b00001000
LEVEL_WAIT_3                   = 0b00001100
LEVEL_WAIT_4                   = 0b00010000
LEVEL_WAIT_5                   = 0b00010100
LEVEL_WAIT_6                   = 0b00011000
LEVEL_WAIT_7                   = 0b00011100
LEVEL_WAIT_8                   = 0b00100000

LEVEL_LANE_TIME_REALLY_SLOW    = 50
LEVEL_LANE_TIME_SLOW           = 40
LEVEL_LANE_TIME_MEDIUM         = 30
LEVEL_LANE_TIME_FAST           = 15
LEVEL_LANE_TIME_REALLY_FAST    = 10
LEVEL_LANE_TIME_ULTRA_FAST     = 4

LEVEL_LANE_BUFFER_ADDRESS_L        = 0
LEVEL_LANE_BUFFER_ADDRESS_H        = 1
LEVEL_LANE_CURRENT_LANE_ADDRESS_L  = 2 
LEVEL_LANE_CURRENT_LANE_ADDRESS_H  = 3
LEVEL_LANE_CURRENT_CMD_DATA1       = 4
LEVEL_LANE_CURRENT_CMD_DATA2       = 5
LEVEL_LANE_CURRENT_CMD_DATA3       = 6
LEVEL_LANE_CURRENT_CMD_PTR_L       = 7
LEVEL_LANE_CURRENT_CMD_PTR_H       = 8
LEVEL_LANE_HAS_FINISHED            = 9
LEVEL_LANE_SIZE                    = 10

;LEVEL_GENERATOR_CURRENT_NUM_LANES  = 1
;LEVEL_GENERATOR_CURRENT_MIN_HP     = 2
;LEVEL_GENERATOR_CURRENT_MAX_HP     = 3
;LEVEL_GENERATOR_LANES_START        = 4
;LEVEL_GENERATOR_LANES_END          = LEVEL_GENERATOR_LANES_START + LEVEL_LANE_SIZE * 3
;LEVEL_GENERATOR_SIZE               = LEVEL_GENERATOR_LANES_END

LEVEL_INIT_PARAMS             = 0
LEVEL_NEXT_LEVEL_ADDRESS_L    = 1
LEVEL_NEXT_LEVEL_ADDRESS_H    = 2
LEVEL_BUFFER_ADDRESES_START   = 3


;; SOUNDS
;;
;; SPELL
;;
    SFX_SPELL           = 3
    SFX_SPELL_VOLUME    = 12   ;; [0-15] 0 = off, 15 = max volume
    SFX_SPELL_NOTE      = 143/2 ;;(143/7)*(5-1) + 3      ;; D-3     ;[0-143]
    SFX_SPELL_SPEED     = 0
    SFX_SPELL_CHANNEL   = 0b00000100        ;; channel 1
;;
;;
;; DEAD
;;
    SFX_DEAD           = 2
    SFX_DEAD_VOLUME    = 12  ;; [0-15] 0 = off, 15 = max volume
    SFX_DEAD_NOTE      = 143/2      ;; C-4     ;[0-143]
    SFX_DEAD_SPEED     = 0
    SFX_DEAD_CHANNEL   = 0b00001000        ;; channel 1
;;

;;
;; HIT
;;
    SFX_HIT           = 4
    SFX_HIT_VOLUME    = 12   ;; [0-15] 0 = off, 15 = max volume
    SFX_HIT_NOTE      = 143/2      ;; C-4   ;[0-143]
    SFX_HIT_SPEED     = 0
    SFX_HIT_CHANNEL   = 0b00010000        ;; channel 1
;;
