;;------------------------------------------------------------------------------
;; This file is part of Farming Spirits.
;;
;; Farming Spirits is free software: you can redistribute it and/or modify
;; it under the terms of the GNU General Public License as published 
;; by the Free Software Foundation, either version 3 of the License, 
;; or (at your option) any later version.
;;
;; Farming Spirits is distributed in the hope that it will be useful, but WITHOUT 
;; ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
;; FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
;; for more details.
;;
;; You should have received a copy of the GNU General Public License 
;; along with Farming Spirits. If not, see https://www.gnu.org/licenses/. 
;;------------------------------------------------------------------------------

ANIM_ARRAY_COUNTER  = 0
ANIM_ARRAY_SPRITE   = 1
ANIM_ARRAY_VALUE    = 1
ANIM_ARRAY_SIZE     = 3


.globl man_animations_getAnim

ANIM_SPEED_FACTOR = 2
;; VALORES DE SPEED DEL ASEPRITE
ANIM_FRAME_SPEED_1000   = (1000 * ANIM_SPEED_FACTOR) /100
ANIM_FRAME_SPEED_500    = (500 * ANIM_SPEED_FACTOR) /100
ANIM_FRAME_SPEED_400    = (400 * ANIM_SPEED_FACTOR) /100
ANIM_FRAME_SPEED_250    = (250 * ANIM_SPEED_FACTOR) /100
ANIM_FRAME_SPEED_200    = (200 * ANIM_SPEED_FACTOR) /100
ANIM_FRAME_SPEED_160    = (160 * ANIM_SPEED_FACTOR) /100
ANIM_FRAME_SPEED_150    = (150 * ANIM_SPEED_FACTOR) /100
ANIM_FRAME_SPEED_120    = (120 * ANIM_SPEED_FACTOR) /100
ANIM_FRAME_SPEED_50     = (50 * ANIM_SPEED_FACTOR) /100

ANIM_ENTITIES_FIRST_FRAME_COUNTER = ANIM_FRAME_SPEED_500
ANIM_ENTITY_DEATH       = 1
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; PLAYER ANIMATIONS
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
ANIM_PLAYER_STANDING    = 0
ANIM_PLAYER_DEATH       = 1
ANIM_PLAYER_SHOOTING    = 2
ANIM_PLAYER_DOWN        = 3
ANIM_PLAYER_UP          = 4
ANIM_PLAYER_SHOOTING_FRAMES    = ANIM_FRAME_SPEED_120 + ANIM_FRAME_SPEED_120 + ANIM_FRAME_SPEED_200 + ANIM_FRAME_SPEED_50 + ANIM_FRAME_SPEED_200
ANIM_PLAYER_DEATH_FRAMES       = ANIM_FRAME_SPEED_120 * 3 + ANIM_FRAME_SPEED_150 * 4 + ANIM_FRAME_SPEED_1000
ANIM_ENEMY_DEATH_FRAMES        = ANIM_FRAME_SPEED_120 * 4 + ANIM_FRAME_SPEED_250
ANIM_ENEMY_DEATH_DAMAGE_FRAMES = ANIM_FRAME_SPEED_120 * 9
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

    .globl _animations_array_player
    .globl man_anim_player_standing
    .globl man_anim_player_up
    .globl man_anim_player_down
    .globl man_anim_player_shooting
    .globl man_anim_player_death
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; ENEMIES
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
ANIM_ENEMY_STANDING         = 0
ANIM_ENEMY_DEATH            = 1
ANIM_ENEMY_DEATH_DAMAGE     = 2
ANIM_ENEMY_WALKING          = 3
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

    .globl man_anim_enemy_death
    .globl man_anim_enemy_death_damage
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; ENEMY FIRE ANIMATIONS
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    .globl _animations_array_enemy_fire
    .globl man_anim_enemy_fire_standing
    .globl man_anim_enemy_fire_walking
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; ENEMY WATER ANIMATIONS
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    .globl _animations_array_enemy_water
    .globl man_anim_enemy_water_standing
    .globl man_anim_enemy_water_walking
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; ENEMY ELECTRIC ANIMATIONS
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    .globl _animations_array_enemy_electric
    .globl man_anim_enemy_electric_standing
    .globl man_anim_enemy_electric_walking
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; ENEMY MIXED ANIMATIONS
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    .globl _animations_array_enemy_mixed
    .globl man_anim_enemy_mixed_standing
    .globl man_anim_enemy_mixed_walking
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; ENEMY LETTER ANIMATIONS
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    .globl _animations_array_enemy_letter
    .globl man_anim_enemy_letter_standing
    .globl man_anim_enemy_letter_walking
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; ENEMY HEART ANIMATIONS
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    .globl _animations_array_enemy_heart
    .globl man_anim_enemy_heart_standing
    .globl man_anim_enemy_heart_walking
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; SPELL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
ANIM_SPELL_SHOOTING    = 0
ANIM_SPELL_DESTROY     = 1
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; SPELL FIRE ANIMATIONS
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    .globl _animations_array_spell_fire
    .globl man_anim_spell_fire
    .globl man_anim_spell_fire_destroy
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; SPELL WATER ANIMATIONS
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    .globl _animations_array_spell_water
    .globl man_anim_spell_water
    .globl man_anim_spell_water_destroy
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; SPELL ELECTRIC ANIMATIONS
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    .globl _animations_array_spell_electric
    .globl man_anim_spell_electric
    .globl man_anim_spell_electric_destroy
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; SPELL LETTER ANIMATIONS
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    .globl _animations_array_spell_letter
    .globl man_anim_spell_letter
    .globl man_anim_spell_letter_destroy
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;