;;------------------------------------------------------------------------------
;; This file is part of Farming Spirits.
;;
;; Farming Spirits is free software: you can redistribute it and/or modify
;; it under the terms of the GNU General Public License as published 
;; by the Free Software Foundation, either version 3 of the License, 
;; or (at your option) any later version.
;;
;; Farming Spirits is distributed in the hope that it will be useful, but WITHOUT 
;; ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
;; FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
;; for more details.
;;
;; You should have received a copy of the GNU General Public License 
;; along with Farming Spirits. If not, see https://www.gnu.org/licenses/. 
;;------------------------------------------------------------------------------

;; Entity types
ENTITY_TYPE_PLAYER       = 0
ENTITY_TYPE_ENEMY        = 1
ENTITY_TYPE_BULLET       = 2

COLLISION_TYPE_PLAYER        = 0x01
COLLISION_TYPE_ENEMY         = 0x02
COLLISION_TYPE_PLAYER_BULLET = 0x04
COLLISION_TYPE_ENEMY_BULLET  = 0x08


;; Entity Components
COMPONENT_RENDER     = #0x01
COMPONENT_UPDATE     = #0x02
COMPONENT_ANIMATED   = #0x04
COMPONENT_COLLIDER   = #0x08
COMPONENT_DEAD_PTR   = #0x10
COMPONENT_DEFAULT    = #0x00

;; Entity State
ENTITY_STATE_DEFAULT          = 0x00
ENTITY_STATE_MOVING           = 0x01
ENTITY_STATE_SHOOTING         = 0x02
ENTITY_STATE_JUST_MOVED       = 0x04
ENTITY_STATE_DYING            = 0x08
ENTITY_STATE_RANDOM_HEALTHBAR = 0x40 
ENTITY_STATE_DEAD             = 0x80


;; Entity struct offsets
ENTITY_NEXT_L              = 0
ENTITY_NEXT_H              = 1
ENTITY_TYPE                = 2
ENTITY_CMPS                = 3
ENTITY_STATE               = 4
ENTITY_X                   = 5
ENTITY_Y                   = 6
ENTITY_W                   = 7
ENTITY_H                   = 8
ENTITY_COLLISION_TYPE      = 9
ENTITY_COLLIDES_AGAINST    = 10
ENTITY_SPRITE_L            = 11
ENTITY_SPRITE_H            = 12
ENTITY_PREV_PTR1_L         = 13
ENTITY_PREV_PTR1_H         = 14
ENTITY_PREV_PTR2_L         = 15
ENTITY_PREV_PTR2_H         = 16
ENTITY_ANIM_L              = 17
ENTITY_ANIM_H              = 18
ENTITY_ANIM_ARRAY_PTR_L    = 19
ENTITY_ANIM_ARRAY_PTR_H    = 20
ENTITY_ANIM_COUNTER        = 21
ENTITY_ANIM_STATUS         = 22 ;; changing between different animations for a character
ENTITY_ANIM_PREV_STATUS    = 23
ENTITY_UPDATE_BEHAVIOUR_L  = 24
ENTITY_UPDATE_BEHAVIOUR_H  = 25
ENTITY_UPDATE_COUNTER      = 26 ;; Until this point, all the fields are common for every entity
ENTITY_LANE_X              = 27
ENTITY_LANE_Y              = 28
ENTITY_LIFE                = 29
ENTITY_VELOCITY            = 30
ENTITY_DEAD_PTR_H          = 31

ENTITY_SIZE                = 32
ENTITY_SIZE_WITH_PTR       = 34

ENTITY_DEAD_PTR_L          = ENTITY_VELOCITY
ENTITY_ENEMY_LINE_X        = ENTITY_LANE_X
ENTITY_ENEMY_LINE_Y        = ENTITY_LANE_Y
ENTITY_ENEMY_LIFE          = ENTITY_LIFE

ENTITY_BULLET_VX           = ENTITY_LANE_X
ENTITY_BULLET_COLOR_MASK   = ENTITY_LANE_Y

BULLET_MIN_X_POSITION = 10
BULLET_MAX_X_POSITION = (16 / 4) * 12

BULLET_FREE_SPACE_MASK      = 0b00000011
BULLET_COLOR_MASK           = 0b11000000
BULLET_YELLOW_COLOR_MASK    = 0b01000000
BULLET_CYAN_COLOR_MASK      = 0b10000000
BULLET_RED_COLOR_MASK       = 0b11000000

;; Animaciones
    ;SpFr_t:
    ;    .dw 0x0000  ;; u8* sprite
    ;    .dw 0x0000 ;; AnimFrame_t* next
    ;; No se tio
    ; AnimFrame_t:
    ;     .db 0x00    ;; u8 time 
    ;     .dw 0x0000  ;; SpriteOrNextFrame_t val
;;
