;;------------------------------------------------------------------------------
;; This file is part of Farming Spirits.
;;
;; Farming Spirits is free software: you can redistribute it and/or modify
;; it under the terms of the GNU General Public License as published 
;; by the Free Software Foundation, either version 3 of the License, 
;; or (at your option) any later version.
;;
;; Farming Spirits is distributed in the hope that it will be useful, but WITHOUT 
;; ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
;; FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
;; for more details.
;;
;; You should have received a copy of the GNU General Public License 
;; along with Farming Spirits. If not, see https://www.gnu.org/licenses/. 
;;------------------------------------------------------------------------------

_SPR_DEFAULT_W = 4
_SPR_DEFAULT_H = 16

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; BUTTONS
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
.globl _spr_button_0
.globl _spr_button_1
.globl _spr_button_2
.globl _spr_button_3

_SPR_BUTTON_W = _SPR_DEFAULT_W
_SPR_BUTTON_H = _SPR_DEFAULT_H
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; ENEMIES
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
.globl _spr_enemy_death_00
.globl _spr_enemy_death_01
.globl _spr_enemy_death_02
.globl _spr_enemy_death_03
.globl _spr_enemy_death_04
.globl _spr_enemy_death_05
.globl _spr_enemy_death_06
.globl _spr_enemy_death_07
.globl _spr_enemy_death_08
.globl _spr_enemy_death_09
.globl _spr_enemy_death_10
.globl _spr_enemy_death_11
.globl _spr_enemy_death_12
.globl _spr_enemy_death_13


.globl _spr_enemy_electric_0
.globl _spr_enemy_electric_1
.globl _spr_enemy_electric_2
.globl _spr_enemy_electric_3
.globl _spr_enemy_electric_4

.globl _spr_enemy_fire_0
.globl _spr_enemy_fire_1
.globl _spr_enemy_fire_2
.globl _spr_enemy_fire_3
.globl _spr_enemy_fire_4

.globl _spr_enemy_letter_0
.globl _spr_enemy_letter_1
.globl _spr_enemy_letter_2
.globl _spr_enemy_letter_3
.globl _spr_enemy_letter_4

.globl _spr_enemy_mixed_0
.globl _spr_enemy_mixed_1
.globl _spr_enemy_mixed_2
.globl _spr_enemy_mixed_3
.globl _spr_enemy_mixed_4

.globl _spr_enemy_water_0
.globl _spr_enemy_water_1
.globl _spr_enemy_water_2
.globl _spr_enemy_water_3
.globl _spr_enemy_water_4

.globl _spr_enemy_heart_0
.globl _spr_enemy_heart_1
.globl _spr_enemy_heart_2
.globl _spr_enemy_heart_3
.globl _spr_enemy_heart_4

_SPR_ENEMY_W = _SPR_DEFAULT_W
_SPR_ENEMY_H = _SPR_DEFAULT_H + 4
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; MARKERS
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
.globl _spr_marker_enemy
_SPR_MARKER_ENEMY_W = _SPR_DEFAULT_W
_SPR_MARKER_ENEMY_H = _SPR_DEFAULT_H + 4


.globl _spr_marker_player
_SPR_MARKER_PLAYER_W = _SPR_DEFAULT_W
_SPR_MARKER_PLAYER_H = _SPR_DEFAULT_H
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; SPELLS
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
.globl _spr_spell_electric_0
.globl _spr_spell_electric_1
.globl _spr_spell_electric_2
.globl _spr_spell_electric_3
.globl _spr_spell_electric_4

.globl _spr_spell_fire_0
.globl _spr_spell_fire_1
.globl _spr_spell_fire_2
.globl _spr_spell_fire_3
.globl _spr_spell_fire_4

.globl _spr_spell_letter_0
.globl _spr_spell_letter_1
.globl _spr_spell_letter_2
.globl _spr_spell_letter_3
.globl _spr_spell_letter_4

.globl _spr_spell_water_0
.globl _spr_spell_water_1
.globl _spr_spell_water_2
.globl _spr_spell_water_3
.globl _spr_spell_water_4

_SPR_SPELL_W = _SPR_DEFAULT_W
_SPR_SPELL_H = _SPR_DEFAULT_H
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; UI
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
.globl _spr_ui_electric_0
.globl _spr_ui_electric_1

.globl _spr_ui_fire_0
.globl _spr_ui_fire_1

.globl _spr_ui_life_0
.globl _spr_ui_life_1

.globl _spr_ui_water_0
.globl _spr_ui_water_1

_SPR_UI_W = _SPR_DEFAULT_W
_SPR_UI_H = _SPR_DEFAULT_H
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; PLAYER
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
.globl _spr_wizard_00
.globl _spr_wizard_01

.globl _spr_wizard_02
.globl _spr_wizard_03
.globl _spr_wizard_04

.globl _spr_wizard_05
.globl _spr_wizard_06
.globl _spr_wizard_07

.globl _spr_wizard_08
.globl _spr_wizard_09
.globl _spr_wizard_10
.globl _spr_wizard_11
.globl _spr_wizard_12

.globl _spr_wizard_13
.globl _spr_wizard_14
.globl _spr_wizard_15
.globl _spr_wizard_16
.globl _spr_wizard_17
.globl _spr_wizard_18
.globl _spr_wizard_19
.globl _spr_wizard_20


_SPR_PLAYER_W = _SPR_DEFAULT_W
_SPR_PLAYER_H = _SPR_DEFAULT_H
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; TUTORIAL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
.globl _spr_tutorial_move
.globl _spr_tutorial_shoot
.globl _spr_tutorial_spell
_SPR_TUTORIAL_W = 42
_SPR_TUTORIAL_H = 20
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;