;;------------------------------------------------------------------------------
;; This file is part of Farming Spirits.
;;
;; Farming Spirits is free software: you can redistribute it and/or modify
;; it under the terms of the GNU General Public License as published 
;; by the Free Software Foundation, either version 3 of the License, 
;; or (at your option) any later version.
;;
;; Farming Spirits is distributed in the hope that it will be useful, but WITHOUT 
;; ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
;; FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
;; for more details.
;;
;; You should have received a copy of the GNU General Public License 
;; along with Farming Spirits. If not, see https://www.gnu.org/licenses/. 
;;------------------------------------------------------------------------------


.module hud

.include "cpctelera.h.s"
.include "../macros.h.s"
.include "../sprites/sprites.h.s"
.include "../constants.h.s"
.include "render_cpctelera32x16.h.s"
.include "../manager/game.h.s"
.include "./level.h.s"

.area _DATA

num_empty_lifes::
    .db 0

.area _CODE


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; PRIVATE FUNCTIONS
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    ;///////////////////////////////////// 
    ;// FUNCTION
    ;//   multiply
    ;// Input:
    ;//     A - Num hearts/attacks
    ;// Return:
    ;//     A * OFFSET
    ;/////////////////////////////////////
    ; multiply_hud:
    ;     ld c, #HUD_NUM_DESPLAZAMIENTOS
    ;     sys_mul_loop:
    ;         sll a
    ;         dec c
    ;     jr nz, sys_mul_loop

    ;     add #HUD_NUM_SOBRANTE
    ;     ret
    ; multiply_hud_offset:
        
    ;     ld c, a ;; counter C = num hearts
    ;     mul_loop_hud:           ;; C * OFFSET
    ;         add #HUD_OFFSET-1   ;;/C += OFFSET-1
    ;         dec c               ;;\ counter--
    ;         ret z               
    ;     jr mul_loop_hud
    ;     ret
    


    ; ;///////////////////////////////////// 
    ; ;// FUNCTION
    ; ;//   Draw hud base
    ; ;/////////////////////////////////////
    ; sys_hud_draw_box_init:
    ;     ;;; Draw HUD box
    ;         ld a, #2        ;; contador
    ;         ld de, #BUFFER_PTR_2
    ;         sys_draw_hud_loop_hud_box:
    ;         push af ;; guardar contador
    ;         ;; dibujamos base en C400 buffer 2
    ;             ld c, #HUD_X
    ;             ld b, #HUD_Y
    ;             call getScreenPtr_32x16

    ;             ld c, #HUD_WIDTH
    ;             ld b, #HUD_HEIGHT
    ;             ld a, #HUD_BACKGROUND_COLOR
    ;             ex de, hl
    ;             call drawSolidBox_32x16
    ;             ;; 
    ;             pop af
    ;             dec a
    ;             jr z, sys_draw_hud_end_loop_hud_box
    ;             ld de, #BUFFER_PTR_1
    ;         jr sys_draw_hud_loop_hud_box
    ;         sys_draw_hud_end_loop_hud_box:
    ;         ;; }

    ;     ;;;}
    ;     ret
    
    ;/////////////////////////////////////
    
    ; ;///////////////////////////////////// 
    ; ;// FUNCTION
    ; ;//   Draw hud base hearts
    ; ;/////////////////////////////////////
    ; sys_hud_draw_hearts_init:
    ;     ld a, #0
    ;     ld (#num_empty_lifes) ,a            ;; set empty lifes
    ;     call sys_hud_draw_hearts        ;; draw hearts
    ;     ret
    

    ;///////////////////////////////////// 
    ;// FUNCTION
    ;//   Reset the num empty lifes variable
    ;// DESTROY
    ;//     AF
    ;/////////////////////////////////////
    sys_hud_reset::
        xor a
        ld (#num_empty_lifes), a
    ret

    ;///////////////////////////////////// 
    ;// FUNCTION
    ;//   Draw lifes
    ;// DESTROY
    ;// A BC DE HL
    ;/////////////////////////////////////
    sys_hud_draw_hearts:
        ;call sys_hud_set_empty_lifes
        ;; SET X AND Y
        ld c, #HUD_HEARTS_SPRITE_X    ;; X
        ld b, #HUD_HEARTS_SPRITE_Y    ;; Y
        ;;SET COUNTER
        ld a, #PLAYER_MAX_HEALTH  ;; variable in GAME.s
        push af
        ;;GET NUMBER LIFES
        ld a, (#num_empty_lifes)
        ld e,a          ;; E = empty_lifes
        pop af          ;; A = Player health

        ;;SET SPRITE
        ld hl, #_spr_ui_life_0                   ;;/
        ld (automodificable_sprite_heart), hl   ;;\ Cambiamos sprite

        ;;; while (a!= 0)
        sys_draw_hud_loop_hearts_init:
            push af                     ; save counter
            push bc                     ; save X and Y

            cp e
            call z, sys_hud_change_to_empty_heart

            push de

            call sys_hud_draw_one_heart
            pop de
            
            pop bc                          ; get X
            ld  a, c                        ; /
            ld  c, #HUD_HEARTS_OFFSET_X     ; | CALCULAR NUEVA POS X
            sub c                           ; | C -= HUD_HEARTS_OFFSET_X
            ld  c, a                        ; \ 


            pop af                          ; get counter
            dec a
            ret z

        jr sys_draw_hud_loop_hearts_init
    
    sys_hud_change_to_empty_heart:
        ld hl, #_spr_ui_life_1                   ;;/
        ld (automodificable_sprite_heart), hl   ;;\ Cambiamos sprite
    ret

    ;///////////////////////////////////// 
    ;// FUNCTION
    ;//   Draw hud base one heart
    ;// Input:
    ;//     B - sprite x
    ;//     C - sprite y 
    ;/////////////////////////////////////
    sys_hud_draw_one_heart:
        ;;; Draw heart
            ld a, #2        ;; contador
            ld de, #BUFFER_PTR_2
            sys_draw_hud_loop_hearts:
                push bc     ;; save X, Y screen ptr
                push af     ;; save counter
            ;; dibujamos base en C400 buffer 2
                ;ld c, #HUD_HEARTS_SPRITE_X
                ld b, #HUD_HEARTS_SPRITE_Y
                call getScreenPtr_32x16

                automodificable_sprite_heart = . + 1    ;; cambiar spr_heart
                ld de, #_spr_ui_life_0
                ld c, #_SPR_UI_W
                ld b, #_SPR_UI_H
                ex de, hl
                call drawSprite_32x16
                ;; 
                pop af  ;; get counter
                dec a   
                pop bc  ;; get X, Y screen ptr
                jr z, sys_draw_hud_end_loop_hearts
                ld de, #BUFFER_PTR_1
            jr sys_draw_hud_loop_hearts
            sys_draw_hud_end_loop_hearts:
            ;; }
        ;;; }
        ret
    ;/////////////////////////////////////


    ;///////////////////////////////////// 
    ;// FUNCTION
    ;//   Draw hud base attaks
    ;// Input:
    ;//     A - Number of attaks
    ;/////////////////////////////////////
    sys_hud_draw_attacks_init:
        ld a, (#level_generator_num_attacks)
        ;;; while (a!= 0)
        sys_draw_hud_loop_attacks_init:
            push af                     ;save a counter
            ld c, #HUD_ATTACK_SPRITE_X_0                     ; X
            ld b, #HUD_ATTACK_SPRITE_Y  ; Y
            ld hl, #_spr_ui_fire_0                   ;;/
            ld (automodificable_sprite_attack), hl   ;;\ Cambiamos sprite
            call sys_hud_draw_one_attack

            pop af
            dec a
            jr z, sys_draw_hud_end_loop_attacks_init
            
            push af                     ;save a counter
            ld c, #HUD_ATTACK_SPRITE_X_1                     ; X
            ld b, #HUD_ATTACK_SPRITE_Y  ; Y
            ld hl, #_spr_ui_electric_0                   ;;/
            ld (automodificable_sprite_attack), hl   ;;\ Cambiamos sprite
            call sys_hud_draw_one_attack

            pop af
            dec a
            jr z, sys_draw_hud_end_loop_attacks_init

            push af                     ;save a counter
            ld c, #HUD_ATTACK_SPRITE_X_2                     ; X
            ld b, #HUD_ATTACK_SPRITE_Y  ; Y
            ld hl, #_spr_ui_water_0                   ;;/
            ld (automodificable_sprite_attack), hl   ;;\ Cambiamos sprite
            call sys_hud_draw_one_attack

            pop af
            dec a
            jr z, sys_draw_hud_end_loop_attacks_init
        ;jr sys_draw_hud_loop_attacks_init
        sys_draw_hud_end_loop_attacks_init:
        ;;; }
        ret
    ;/////////////////////////////////////

    ;///////////////////////////////////// 
    ;// FUNCTION
    ;//   Draw hud base one attak
    ;// Input:
    ;//     B - sprite x
    ;//     C - sprite y 
    ;/////////////////////////////////////
    sys_hud_draw_one_attack:
        ;;; Draw attacks
            ld a, #2        ;; contador
            ld de, #BUFFER_PTR_2
            sys_draw_hud_loop_attack_init:
                push bc
                push af ;; guardar contador
            ;; dibujamos base en C400 buffer 2
                ;ld c, #HUD_ATTACK_SPRITE_X
                ;ld b, #HUD_ATTACK_SPRITE_Y
                call getScreenPtr_32x16
                
                automodificable_sprite_attack = . + 1
                ld de, #_spr_ui_water_0
                ld c, #HUD_ATTACK_SPRITE_WIDTH
                ld b, #HUD_ATTACK_SPRITE_HEIGHT
                ex de, hl
                call drawSprite_32x16
                ;; 
                pop af
                pop bc
                dec a
                jr z, sys_draw_hud_end_loop_attack_init
                ld de, #BUFFER_PTR_1
            jr sys_draw_hud_loop_attack_init
            sys_draw_hud_end_loop_attack_init:
        ;;;}
        ret
    ;/////////////////////////////////////

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; PUBLIC FUNCTIONS
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    ;/////////////////////////////////////
    ;// FUNCTION
    ;//   Draw hud base
    ;/////////////////////////////////////
    sys_draw_hud::
        call sys_hud_draw_hearts
        
        call sys_hud_draw_attacks_init 
        call sys_hud_set_active_attack   
        ret
    ;/////////////////////////////////////
    sys_hud_add_heart::

        ld a, (#num_empty_lifes)
        dec a
        ld (#num_empty_lifes) ,a            ;; set empty lifes
        call sys_hud_draw_hearts
    ret
    sys_hud_remove_heart::

        ld a, (#num_empty_lifes)
        inc a
        ld (#num_empty_lifes),a            ;; set empty lifes
        call sys_hud_draw_hearts
    ret


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; SETTERS
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    ;/////////////////////////////////////
    ;// Set active attack
    ;//
    ;// Input:
    ;//     A - Active Attack [0-2]
    ;/////////////////////////////////////
        sys_hud_set_active_attack::
            push af
            call sys_hud_set_inactive_attack
            pop af
            ld hl, #_spr_ui_fire_1                  ;;/ Spell 0
            ld (automodificable_sprite_attack), hl   ;;\ Cambiamos sprite
            ;;; if(a == 0) {
                xor #0
                jr nz, sys_hud_set_active_attack_if_1
                ;; @( a == 0 )@
                    ld c, #HUD_ATTACK_SPRITE_X_0
                    ld b, #HUD_ATTACK_SPRITE_Y
                    call sys_hud_draw_one_attack
                    ret
                ;; 
            sys_hud_set_active_attack_if_1:
            ;;; } else if ( A == 1) {
                dec a
                xor #0
                jr nz, sys_hud_set_active_attack_if_2
                    ld c, #HUD_ATTACK_SPRITE_X_1
                    ld b, #HUD_ATTACK_SPRITE_Y
                    ld hl, #_spr_ui_water_1                  ;;/ Spell 1
                    ld (automodificable_sprite_attack), hl   ;;\ Cambiamos sprite
                    call sys_hud_draw_one_attack
                ret
                sys_hud_set_active_attack_if_2:
            ;;; } else {
                ld c, #HUD_ATTACK_SPRITE_X_2
                ld b, #HUD_ATTACK_SPRITE_Y
                ld hl, #_spr_ui_electric_1                  ;;/ Spell 2
                ld (automodificable_sprite_attack), hl   ;;\ Cambiamos sprite
                call sys_hud_draw_one_attack
            ;;; }
            
            ret
    ;/////////////////////////////////////
    ;/////////////////////////////////////
    ;// Set inactive attack
    ;// PRIVATE only for set_active
    ;// Input:
    ;//     A - Active Attack [0-2]
    ;/////////////////////////////////////
    sys_hud_set_inactive_attack:
        ld hl, #_spr_ui_fire_0                   ;;/
        ld (automodificable_sprite_attack), hl   ;;\ Cambiamos sprite
        push af ;; save active attack
        ;;; if (num_attacks == 1) ;return {
            ld a, (#level_generator_num_attacks)
            xor #1
            jr nz,sys_hud_set_inactive_attack_hacer_pop
            pop af
            ret 
        ;;; }
        sys_hud_set_inactive_attack_hacer_pop:
        pop af  ;; save active attack
        ;;; if(a == 0) {
            xor #0
            jr nz, sys_hud_set_inactive_attack_if_1
            ;; @( a == 0 )@
                    ld c, #HUD_ATTACK_SPRITE_X_1
                    ld b, #HUD_ATTACK_SPRITE_Y
                    ld hl, #_spr_ui_water_0                   ;;/
                    ld (automodificable_sprite_attack), hl   ;;\ Cambiamos sprite
                    call sys_hud_draw_one_attack        ;; | Spell 1
                    ;;; if (num_attacks == 2) ;return {
                        ld a, (#level_generator_num_attacks)
                        xor #2
                        ret z
                    ;;; }
                    ld c, #HUD_ATTACK_SPRITE_X_2
                    ld b, #HUD_ATTACK_SPRITE_Y
                    ld hl, #_spr_ui_electric_0                   ;;/
                    ld (automodificable_sprite_attack), hl   ;;\ Cambiamos sprite
                    call sys_hud_draw_one_attack    ;; | Spell 2
                    ret
            ;; 
        sys_hud_set_inactive_attack_if_1:
        ;;; } else if ( A == 1) {
            xor #1
            jr nz, sys_hud_set_inactive_attack_if_2
                ld c, #HUD_ATTACK_SPRITE_X_0
                ld b, #HUD_ATTACK_SPRITE_Y
                ld hl, #_spr_ui_fire_0                   ;;/
                ld (automodificable_sprite_attack), hl   ;;\ Cambiamos sprite
                call sys_hud_draw_one_attack            ;; | Spell 0
                ;;; if (num_attacks == 2) ;return {
                    ld a, (#level_generator_num_attacks)
                    xor #2
                    ret z
                ;;; }
                ld c, #HUD_ATTACK_SPRITE_X_2
                ld b, #HUD_ATTACK_SPRITE_Y
                ld hl, #_spr_ui_electric_0                   ;;/
                ld (automodificable_sprite_attack), hl  ;;\ Cambiamos sprite
                call sys_hud_draw_one_attack            ;; | Spell 2
                ret
            sys_hud_set_inactive_attack_if_2:
        ;;; } else {
            ld c, #HUD_ATTACK_SPRITE_X_0
            ld b, #HUD_ATTACK_SPRITE_Y
            ld hl, #_spr_ui_fire_0                   ;;/
            ld (automodificable_sprite_attack), hl   ;;\ Cambiamos sprite
            call sys_hud_draw_one_attack            ;; | Spell 0
            ld c, #HUD_ATTACK_SPRITE_X_1
            ld b, #HUD_ATTACK_SPRITE_Y
            ld hl, #_spr_ui_water_0                   ;;/
            ld (automodificable_sprite_attack), hl   ;;\ Cambiamos sprite
            call sys_hud_draw_one_attack            ;; Spell 1
        ;;; }
        
        ret
    ;/////////////////////////////////////

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;



;; FUNCIONES ANTES
;///////////////////////////////////// 
    ;// FUNCTION
    ;//   Draw hud base hearts
    ;// Input:
    ;//     A - num lifes
    ;/////////////////////////////////////
    ;antes_sys_hud_draw_hearts_init:
    ;    ld a, (#num_lifes)  ;; get number of lifes
    ;    call antes_sys_hud_draw_hearts_aux    ;; draw hearts
    ;    ret
    ;
    ;antes_sys_hud_draw_hearts_aux:
    ;    call multiply_hud_offset    ;; return offset*a
    ;    
    ;    push af
    ;    add #HUD_HEARTS_SPRITE_X    ;; #A + HUD_HEARTS_SPRITE
    ;    ld (#last_position_x_hearts), a ; save last position
    ;    pop af
    ;    ;;; while (a!= 0)
    ;    antes_sys_draw_hud_loop_hearts_init:
    ;        
    ;        add #HUD_HEARTS_SPRITE_X    ;; #A + HUD_HEARTS_SPRITE
    ;        ; ld (#last_position_x_hearts), a ; save last position
    ;        push af                     ; save counter
    ;        
    ;        ld c, a                     ; C = A = pos_x
    ;        ld b, #HUD_HEARTS_SPRITE_Y  ; Y
    ;        call sys_hud_draw_one_heart
    ;        
    ;        pop af                      ; get counter loop
    ;        sub #HUD_OFFSET             ;; quitar offset
    ;        sub #HUD_HEARTS_SPRITE_X    ;; volver a x = 0
    ;            ;; aqui tenemos -> counter i = 1,2,3 etc
    ;        jr z, antes_sys_draw_hud_end_loop_hearts_init
    ;        jp m, antes_sys_draw_hud_end_loop_hearts_init
    ;    jr antes_sys_draw_hud_loop_hearts_init
    ;    antes_sys_draw_hud_end_loop_hearts_init:
    ;    ;;; }
    ;    ret
            
    ;/////////////////////////////////////
    ;sys_hud_add_heart::
    ;    
    ;    ;; last position += width
    ;    ld a, (#last_position_x_hearts)
    ;    sub #HUD_HEARTS_OFFSET_X
    ;    ld (#last_position_x_hearts), a
    ;    ;; draw
    ;    ld c, a ;; X = A
    ;    call sys_hud_draw_one_heart
    ;    ret
    ;sys_hud_remove_heart::
    ;    
    ;    ;; draw
    ;    ld a, (#last_position_x_hearts)
    ;    ld c, a ;; X = A
    ;    call sys_hud_draw_one_heart
    ;    ;; last position -= width
    ;    ld a, (#last_position_x_hearts)
    ;    add #HUD_HEARTS_OFFSET_X
    ;    ld (#last_position_x_hearts), a
    ;    ret