;;------------------------------------------------------------------------------
;; This file is part of Farming Spirits.
;;
;; Farming Spirits is free software: you can redistribute it and/or modify
;; it under the terms of the GNU General Public License as published 
;; by the Free Software Foundation, either version 3 of the License, 
;; or (at your option) any later version.
;;
;; Farming Spirits is distributed in the hope that it will be useful, but WITHOUT 
;; ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
;; FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
;; for more details.
;;
;; You should have received a copy of the GNU General Public License 
;; along with Farming Spirits. If not, see https://www.gnu.org/licenses/. 
;;------------------------------------------------------------------------------


.module sounds

.include "cpctelera.h.s"
.include "../cpctelera_includes.h.s"
;.include "../manager/entity.h.s"
;.include "../manager/entity_manager.h.s"
.include "../macros.h.s"
;.include "render_cpctelera32x16.h.s"
.include "../constants.h.s"
.include "../music/music.h.s"

.area _DATA

.area _CODE


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; PRIVATE FUNCTIONS
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;/*////////////////////////////////////
    ;/*/ FUNCTION
    ;/*/   Function to play sfx of spells
    ;/*////////////////////////////////////
    sys_sounds_play_init:
       
        ;;? (2B DE) sfx_song_data	Pointer to the start of a song file containing instrument data for SFX
        ld de, #_song_game
        call cpct_akp_SFXInit_asm

        ret
    ;/*////////////////////////////////////
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; PUBLIC FUNCTIONS
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    
    ;/*////////////////////////////////////
    ;/*/ FUNCTION
    ;/*/   Function to play sfx of spells
    ;/*////////////////////////////////////
    sys_sounds_play_spell::
       
        call sys_sounds_play_init

        ;;? (1B L ) sfx_num	Number of the instrument in the SFX Song (>0), same as the number given to the instrument in Arkos Tracker.
        ;;? (1B H ) volume	Volume [0-15], 0 = off, 15 = maximum volume.
        ;;? (1B E ) note	Note to be played with the given instrument [0-143]
        ;;? (1B D ) speed	Speed (0 = As original, [1-255] = new Speed (1 is fastest))
        ;;? (2B BC) inverted_pitch	Inverted Pitch (-0xFFFF -> 0xFFFF).  0 is no pitch.  The higher the pitch, the lower the sound.
        ;;? (1B A ) channel_bitmask	Bitmask representing channels to use for reproducing the sound (Ch.A = 001 (1), Ch.B = 010 (2), Ch.C = 100 (4))

        ld l, #SFX_SPELL
        ld h, #SFX_SPELL_VOLUME
        ld e, #SFX_SPELL_NOTE
        ld d, #SFX_SPELL_SPEED
        ld bc, #0
        ld a, #SFX_SPELL_CHANNEL
        call cpct_akp_SFXPlay_asm


        ret
    ;/*////////////////////////////////////
    ;/*////////////////////////////////////
    ;/*/ FUNCTION
    ;/*/   Function to play sfx of spells
    ;/*////////////////////////////////////
    sys_sounds_play_dead::
       
        call sys_sounds_play_init

        ;;? (1B L ) sfx_num	Number of the instrument in the SFX Song (>0), same as the number given to the instrument in Arkos Tracker.
        ;;? (1B H ) volume	Volume [0-15], 0 = off, 15 = maximum volume.
        ;;? (1B E ) note	Note to be played with the given instrument [0-143]
        ;;? (1B D ) speed	Speed (0 = As original, [1-255] = new Speed (1 is fastest))
        ;;? (2B BC) inverted_pitch	Inverted Pitch (-0xFFFF -> 0xFFFF).  0 is no pitch.  The higher the pitch, the lower the sound.
        ;;? (1B A ) channel_bitmask	Bitmask representing channels to use for reproducing the sound (Ch.A = 001 (1), Ch.B = 010 (2), Ch.C = 100 (4))

        ld l, #SFX_DEAD
        ld h, #SFX_DEAD_VOLUME
        ld e, #SFX_DEAD_NOTE
        ld d, #SFX_DEAD_SPEED
        ld bc, #0
        ld a, #SFX_DEAD_CHANNEL
        call cpct_akp_SFXPlay_asm


        ret
    ;/*////////////////////////////////////
    ;/*////////////////////////////////////
    ;/*/ FUNCTION
    ;/*/   Function to play sfx of spells
    ;/*////////////////////////////////////
    sys_sounds_play_hit::
       
        call sys_sounds_play_init

        ;;? (1B L ) sfx_num	Number of the instrument in the SFX Song (>0), same as the number given to the instrument in Arkos Tracker.
        ;;? (1B H ) volume	Volume [0-15], 0 = off, 15 = maximum volume.
        ;;? (1B E ) note	Note to be played with the given instrument [0-143]
        ;;? (1B D ) speed	Speed (0 = As original, [1-255] = new Speed (1 is fastest))
        ;;? (2B BC) inverted_pitch	Inverted Pitch (-0xFFFF -> 0xFFFF).  0 is no pitch.  The higher the pitch, the lower the sound.
        ;;? (1B A ) channel_bitmask	Bitmask representing channels to use for reproducing the sound (Ch.A = 001 (1), Ch.B = 010 (2), Ch.C = 100 (4))

        ld l, #SFX_HIT
        ld h, #SFX_HIT_VOLUME
        ld e, #SFX_HIT_NOTE
        ld d, #SFX_HIT_SPEED
        ld bc, #0
        ld a, #SFX_HIT_CHANNEL
        call cpct_akp_SFXPlay_asm


        ret
    ;/*////////////////////////////////////
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;